VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1920
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2985
   LinkTopic       =   "Form1"
   ScaleHeight     =   1920
   ScaleWidth      =   2985
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Height          =   375
      Left            =   1680
      TabIndex        =   11
      Top             =   240
      Width           =   615
   End
   Begin VB.TextBox txtVolume 
      Height          =   285
      Left            =   960
      TabIndex        =   10
      Text            =   "C:\"
      Top             =   240
      Width           =   495
   End
   Begin VB.Label Label2 
      Caption         =   "Volume"
      Height          =   255
      Left            =   240
      TabIndex        =   9
      Top             =   240
      Width           =   615
   End
   Begin VB.Label lblPercentTotal 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   2040
      TabIndex        =   8
      Top             =   720
      Width           =   735
   End
   Begin VB.Label lblPercentUsed 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   2040
      TabIndex        =   7
      Top             =   1440
      Width           =   735
   End
   Begin VB.Label lblPercentFree 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   2040
      TabIndex        =   6
      Top             =   1080
      Width           =   735
   End
   Begin VB.Label lblUsed 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   960
      TabIndex        =   5
      Top             =   1440
      Width           =   855
   End
   Begin VB.Label lblFree 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   960
      TabIndex        =   4
      Top             =   1080
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Total:"
      Height          =   255
      Index           =   2
      Left            =   240
      TabIndex        =   3
      Top             =   720
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Used:"
      Height          =   255
      Index           =   1
      Left            =   240
      TabIndex        =   2
      Top             =   1440
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Free:"
      Height          =   255
      Index           =   0
      Left            =   240
      TabIndex        =   1
      Top             =   1080
      Width           =   615
   End
   Begin VB.Label lblTotal 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   960
      TabIndex        =   0
      Top             =   720
      Width           =   855
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type LARGE_INTEGER
    lowpart As Long
    highpart As Long
End Type

Private Declare Function GetDiskFreeSpaceEx Lib "kernel32" Alias "GetDiskFreeSpaceExA" (ByVal lpRootPathName As String, lpFreeBytesAvailableToCaller As LARGE_INTEGER, lpTotalNumberOfBytes As LARGE_INTEGER, lpTotalNumberOfFreeBytes As LARGE_INTEGER) As Long
' Convert a LARGE_INTEGER structure into
' data type to a Double.
Private Function LargeIntegerToDouble(low_part As Long, high_part As Long) As Double
Dim result As Double

    result = high_part
    If high_part < 0 Then result = result + 2 ^ 32
    result = result * 2 ^ 32

    result = result + low_part
    If low_part < 0 Then result = result + 2 ^ 32

    LargeIntegerToDouble = result
End Function
Private Sub cmdGo_Click()
Dim bytes_avail As LARGE_INTEGER
Dim bytes_total As LARGE_INTEGER
Dim bytes_free As LARGE_INTEGER
Dim dbl_total As Double
Dim dbl_free As Double

    ' Get the space values.
    GetDiskFreeSpaceEx txtVolume.Text, bytes_avail, bytes_total, bytes_free

    ' Convert values into Doubles.
    dbl_total = LargeIntegerToDouble(bytes_total.lowpart, bytes_total.highpart)
    dbl_free = LargeIntegerToDouble(bytes_free.lowpart, bytes_free.highpart)

    lblTotal.Caption = FormatBytes(dbl_total)
    lblFree.Caption = FormatBytes(dbl_free)
    lblUsed.Caption = FormatBytes(dbl_total - dbl_free)
    lblPercentTotal.Caption = Format$(1, "percent")
    lblPercentFree.Caption = Format$(dbl_free / dbl_total, "percent")
    lblPercentUsed.Caption = Format$((dbl_total - dbl_free) / dbl_total, "percent")
End Sub
' Return a formatted string representing the number of
' bytes.
Private Function FormatBytes(ByVal num_bytes As Double) As _
    String
Const ONE_KB As Double = 1024
Const ONE_MB As Double = ONE_KB * 1024
Const ONE_GB As Double = ONE_MB * 1024
Const ONE_TB As Double = ONE_GB * 1024
Const ONE_PB As Double = ONE_TB * 1024
Const ONE_EB As Double = ONE_PB * 1024
Const ONE_ZB As Double = ONE_EB * 1024
Const ONE_YB As Double = ONE_ZB * 1024
Dim value As Double
Dim txt As String

    ' See how big the value is.
    If num_bytes <= 999 Then
        ' Format in bytes.
        FormatBytes = Format$(num_bytes, "0") & " bytes"
    ElseIf num_bytes <= ONE_KB * 999 Then
        ' Format in KB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_KB) & " KB"
    ElseIf num_bytes <= ONE_MB * 999 Then
        ' Format in MB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_MB) & " MB"
    ElseIf num_bytes <= ONE_GB * 999 Then
        ' Format in GB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_GB) & " GB"
    ElseIf num_bytes <= ONE_TB * 999 Then
        ' Format in TB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_TB) & " TB"
    ElseIf num_bytes <= ONE_PB * 999 Then
        ' Format in PB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_PB) & " PB"
    ElseIf num_bytes <= ONE_EB * 999 Then
        ' Format in EB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_EB) & " EB"
    ElseIf num_bytes <= ONE_ZB * 999 Then
        ' Format in ZB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_ZB) & " ZB"
    Else
        ' Format in YB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_YB) & " YB"
    End If
End Function

' Return the value formatted to include at most three
' non-zero digits and at most two digits after the decimal
' point. Examples:
'         1
'       123
'        12.3
'         1.23
'         0.12
Private Function ThreeNonZeroDigits(ByVal value As Double) _
    As String
    If value >= 100 Then
        ' No digits after the decimal.
        ThreeNonZeroDigits = Format$(CInt(value))
    ElseIf value >= 10 Then
        ' One digit after the decimal.
        ThreeNonZeroDigits = Format$(value, "0.0")
    Else
        ' Two digits after the decimal.
        ThreeNonZeroDigits = Format$(value, "0.00")
    End If
End Function


